# ory_keto_client
Ory Keto is a cloud native access control server providing best-practice patterns (RBAC, ABAC, ACL, AWS IAM Policies, Kubernetes Roles, ...) via REST APIs.

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v0.7.0-alpha.1
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen
For more information, please visit [https://www.ory.sh](https://www.ory.sh)

## Requirements

Dart 2.7.0 or later OR Flutter 1.12 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: ory_keto_client
version: 0.7.0-alpha.1
description: OpenAPI API client
dependencies:
  ory_keto_client:
    git: https://github.com/ory/sdk.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  ory_keto_client:
    path: /path/to/ory_keto_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:ory_keto_client/api.dart';


final api = HealthApi();

try {
    final response = await api.isInstanceAlive();
    print(response);
} catch (e) {
    print("Exception when calling HealthApi->isInstanceAlive: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*HealthApi* | [**isInstanceAlive**](doc/HealthApi.md#isinstancealive) | **GET** /health/alive | Check alive status
*HealthApi* | [**isInstanceReady**](doc/HealthApi.md#isinstanceready) | **GET** /health/ready | Check readiness status
*ReadApi* | [**getCheck**](doc/ReadApi.md#getcheck) | **GET** /check | Check a relation tuple
*ReadApi* | [**getExpand**](doc/ReadApi.md#getexpand) | **GET** /expand | Expand a Relation Tuple
*ReadApi* | [**getRelationTuples**](doc/ReadApi.md#getrelationtuples) | **GET** /relation-tuples | Query relation tuples
*ReadApi* | [**postCheck**](doc/ReadApi.md#postcheck) | **POST** /check | Check a relation tuple
*VersionApi* | [**getVersion**](doc/VersionApi.md#getversion) | **GET** /version | Get service version
*WriteApi* | [**createRelationTuple**](doc/WriteApi.md#createrelationtuple) | **PUT** /relation-tuples | Create a Relation Tuple
*WriteApi* | [**deleteRelationTuple**](doc/WriteApi.md#deleterelationtuple) | **DELETE** /relation-tuples | Delete a Relation Tuple
*WriteApi* | [**patchRelationTuples**](doc/WriteApi.md#patchrelationtuples) | **PATCH** /relation-tuples | Patch Multiple Relation Tuples


## Documentation For Models

 - [ExpandTree](doc/ExpandTree.md)
 - [GetCheckResponse](doc/GetCheckResponse.md)
 - [GetRelationTuplesResponse](doc/GetRelationTuplesResponse.md)
 - [HealthNotReadyStatus](doc/HealthNotReadyStatus.md)
 - [HealthStatus](doc/HealthStatus.md)
 - [InlineResponse400](doc/InlineResponse400.md)
 - [InternalRelationTuple](doc/InternalRelationTuple.md)
 - [PatchDelta](doc/PatchDelta.md)
 - [RelationQuery](doc/RelationQuery.md)
 - [SubjectSet](doc/SubjectSet.md)
 - [Version](doc/Version.md)


## Documentation For Authorization

 All endpoints do not require authorization.


## Author

hi@ory.sh


